// Program :  Services Name, Description, ImagePath, Status
// Delphi 7 Enterprise

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,
  Registry, WinSvc, ComCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  GetallIPStr : String;
  PCHostName : String;
  MAC_Addresses : String;
  DefaultLang : String;
  OSText : String;
  CurDateTime : String;

implementation

{$R *.dfm}

function GetServiceStatus(service:string): String;
var
  service_manager_handle, service_handle:SC_Handle;
  ss :TServiceStatus;
  ServiceStatus : String;
begin
  service_manager_handle:=OpenSCManager(Nil,Nil,SC_MANAGER_ALL_ACCESS);
  service_handle:=OpenService(Service_manager_handle,PChar(service), SERVICE_ALL_ACCESS);
  if (service_handle > 0) then
  begin
    if QueryServiceStatus(service_handle, ss) then
    begin
      case ss.dwCurrentState of
        SERVICE_STOPPED: ServiceStatus:='STOPPED';   // STOPPED w
        SERVICE_START_PENDING: ServiceStatus:='START_PENDING';
        SERVICE_STOP_PENDING: ServiceStatus:='STOP_PENDING';
        SERVICE_CONTINUE_PENDING: ServiceStatus:='CONTINUE_PENDING';
        SERVICE_PAUSE_PENDING:  ServiceStatus:='PAUSE_PENDING';
        SERVICE_RUNNING: ServiceStatus:='RUNNING';   // RUNNING  wҰ
      else
        ServiceStatus:='䥦';
      end; // case
    end; // if
    CloseServiceHandle(service_handle);
  end; // if
  CloseServiceHandle(service_manager_handle);
  Result := ServiceStatus;
end;

function QueryServices: String;
var
  i : Integer;
  Registry: TRegistry;
  RegistryKeyCount : Integer;

  RootKey : String;
  Key : String;

  KeyName : String;
  ImagePath : String;
  Description : String;
  ServiceStatus : String;

  SubKey: TStringList;
  ValueName: TStringList;
  ResultStr : String;
begin

    RootKey := 'HKEY_LOCAL_MACHINE';
    Key := '\SYSTEM\CurrentControlSet\Services';

    Registry:=TRegistry.Create;
    Subkey := TStringList.Create;
    ValueName := TStringList.Create;

    Registry.RootKey:=HKEY_LOCAL_MACHINE;
    Registry.OpenKey('\SYSTEM\CurrentControlSet\Services\', False);
    Registry.GetKeyNames(SubKey);

    RegistryKeyCount := SubKey.Count-1;
    for I:=0 to RegistryKeyCount do
    begin
      if Registry.OpenKey(Key + '\'+SubKey[I], False) then
      begin
        KeyName := SubKey[i];
        Registry.GetValueNames(ValueName);
        Description := Registry.ReadString('Description');
        ImagePath := Registry.ReadString('ImagePath');
        ServiceStatus:=GetServiceStatus(KeyName);

        if (ImagePath<>'') then
        begin
          // ̧ Keyname, Description, ImagePath, FileSize, FileDate, FileMD5
          ResultStr := ResultStr + '------------------------------------------------------------------------------------------------------------' + #13#10;
          ResultStr := ResultStr + 'Service Name  : ' + KeyName + #13#10;
          ResultStr := ResultStr + 'Description : ' + Description + #13#10;
          ResultStr := ResultStr + 'Program Path : ' + ImagePath + #13#10;
          ResultStr := ResultStr + 'Service Status : ' + ServiceStatus + #13#10;
        end;
        Registry.CloseKey;
      end;
    end;  //for I:=0 to Val.Count-1 do

  SubKey.Clear;
  ValueName.Clear;
  Registry.Free;
  Result := ResultStr ;

end;
procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Clear;
  Memo1.WordWrap:=False;
  Memo1.ScrollBars:=ssBoth;
  Memo1.Lines.Add(QueryServices);
end;

end.
